#include "Robot.h"
#include "MedianFilter.h"

#define RAD 3.14 / 180

MedianFilter filterDirection(3, 0);
Motor A (12, 42, 40);
Motor B (8, 46, 44);
Motor C (6, 34, 32);
Motor D (2, 38, 36);
IRLocator locator;
IRSeeker seeker;
Led ledL(11);
Led ledM(7);
Led ledR(3);
Gyro gyro;

void setup() {
  Serial.begin(9600);
  Serial3.begin(115200);
  
  locator.init();
  seeker.init();

  // Motors
  pinMode(10, OUTPUT);
  digitalWrite(10, HIGH);
  pinMode(4, OUTPUT);
  digitalWrite(4, HIGH);

  // Sensors
  pinMode(33, OUTPUT);
  pinMode(35, OUTPUT);

  // Buttons
  pinMode(13, INPUT_PULLUP);
  pinMode(9, INPUT_PULLUP);
  pinMode(5, INPUT_PULLUP);

  gyro.init(12000);
}

int angle(){
  int dir = locator.getDir1200();
  float k = 1;
  if (abs(dir) >= 140 && seeker.getDir600() == 0)
    dir = 170 * dir / abs(dir);
  else if (abs(dir) >= 140 && seeker.getDir1200() != 0)
    dir = 0;
  if (abs(dir) <= 13)
    dir = 0;
  else if(abs(dir) <= 60)
    k = 2;
  else if(abs(dir) <= 110)
    k = 1.75;
  else if(abs(dir) <= 140)
    k = 1.5;
  else
    dir = -165 * dir / abs(dir);
  filterDirection.in(dir * k);
  return filterDirection.out();
}

void move(int speed, int angle){
  int error = gyro.read() * 4;
  A.start(-speed * cos((angle - 135) * RAD) + error);
  B.start(-speed * cos((angle + 135) * RAD) + error);
  C.start(-speed * cos((angle + 45) * RAD) + error);
  D.start(-speed * cos((angle - 45) * RAD) + error);
}

int sensors() {
  int result = 0;
  static int res;
  static uint32_t t;
  for (int i = 0; i < 4; i++) {
    digitalWrite(33, i % 2);
    digitalWrite(35, (int(i / 2) % 2));
    if (analogRead(A0) > 750){
      result |= 1;
    }
    if (analogRead(A1) > 750){
      result |= 2;
    }
    if (analogRead(A2) > 750){
      result |= 8;
    }
    if (analogRead(A3) > 750){
      result |= 4;
    }
  }
  if (result != 0){
    res = result;
    t = millis();
  }
  else if (millis() - t < 500) return res;
  return result;
}

void loop() {
  Serial.println(seeker.getDir600());
  //Serial.println(sensors());
}
